-- 
-- CREATE  the database needed for the trouble ticket server
--
-- Author Carsten Zerbst carsten.zerbst@groy-groy.de
-- Version 0.1 14.04.2002
--
-- this script contains some drop statements to run 
-- even a second, third ... time without problems after a
-- dropdb tticket
-- dropuser ticketmaster
--
-- Many checks missing
-- Views for product tickets missing
--

-- CREATE the SEQUENCEs needed for tickets and stati
DROP SEQUENCE ticketId_serial;
CREATE SEQUENCE ticketId_serial;
DROP SEQUENCE statusId_serial;
CREATE SEQUENCE statusId_serial;

-- the TABLE for possible products
CREATE TABLE products (
	name VARCHAR(100) PRIMARY KEY,
	description VARCHAR
);

GRANT SELECT ON products TO PUBLIC;

-- the TABLE for platforms
CREATE TABLE platforms (
	name VARCHAR PRIMARY KEY
);
GRANT SELECT ON platforms TO PUBLIC;

INSERT INTO platforms VALUES ('All');
INSERT INTO platforms VALUES ('Linux');
INSERT INTO platforms VALUES ('Solaris');
INSERT INTO platforms VALUES ('Windows 98, ME');
INSERT INTO platforms VALUES ('Windows NT/2000');
INSERT INTO platforms VALUES ('Windows XP Home Edition');
INSERT INTO platforms VALUES ('Windows XP Professional Edition');

-- the TABLE for priorities
CREATE TABLE priorities (
	name VARCHAR(15) PRIMARY KEY,
	description VARCHAR
);

GRANT SELECT ON platforms TO PUBLIC;

INSERT INTO priorities VALUES ('Blocker', 'Blocks development and/or testing work.');
INSERT INTO priorities VALUES ('Critical', 'Crashes, loss of data, severe memory leak.');
INSERT INTO priorities VALUES ('Major', 'Major loss of function.');
INSERT INTO priorities VALUES ('Normal', 'This is the run of the mill bug.');
INSERT INTO priorities VALUES ('Minor', 'Minor loss of function, or other problem where an easy workaround is present.');
INSERT INTO priorities VALUES ('Trivial', 'Cosmetic problem like misspelled words or misaligned text.');
INSERT INTO priorities VALUES ('Enhancement', 'Request for enhancement.');


-- the TABLE for usersInfo. The troubleticket server
-- uses ordinary postgres users and add here some 
-- more information. 
CREATE TABLE usersInfo (
	usename name PRIMARY KEY,
	firstname VARCHAR,
	lastname VARCHAR NOT NULL,	
	email VARCHAR NOT NULL,
	telephone VARCHAR
);


INSERT INTO usersInfo VALUES ('ticketmaster', 'Your', 'Name', 
	'someone@provider.org',''); 

-- the status of a trouble ticket
CREATE TABLE categories (
	name VARCHAR(15) PRIMARY KEY,
	description VARCHAR
);

GRANT SELECT ON categories TO PUBLIC;

INSERT INTO categories VALUES ('unconfirmed','A user submitted this bug, no one checked it''s existence');
INSERT INTO categories VALUES ('new', 
	'This bug was check on existance and is assigned to someone working on it');
INSERT INTO categories VALUES ('resolved', 'the bug is resolved');
INSERT INTO categories VALUES ('reopend', 'the bug is still there ...');
INSERT INTO categories VALUES ('closed', 'the bug is resolved and work for the customer');

-- the TABLE for tickets
CREATE TABLE tickets (
	ticketId integer PRIMARY KEY default nextval('ticketId_serial'),
	productId VARCHAR REFERENCES products,
	version VARCHAR NOT NULL,
	platform VARCHAR REFERENCES platforms,
	priority VARCHAR REFERENCES priorities,
	subject VARCHAR(100) NOT NULL,
	description VARCHAR NOT NULL
);	


GRANT SELECT, INSERT ON tickets TO PUBLIC;

--- the table for ticket stati
CREATE TABLE stati (
	statusid INTEGER PRIMARY KEY default nextval('statusId_serial'),
	ticketid INTEGER REFERENCES tickets,
	date TIMESTAMP DEFAULT 'today',
	issuedBy NAME REFERENCES usersInfo,
	category VARCHAR REFERENCES categories
	description VARCHAR;
);

GRANT SELECT, INSERT ON stati TO PUBLIC;

--- Sample data
INSERT INTO products VALUES ('testproduct', 'a sample product');

DROP GROUP testproduct;
CREATE GROUP testproduct WITH USER ticketmaster;

DROP USER samplecustomer;
CREATE USER samplecustomer WITH PASSWORD 'DAU' IN GROUP testproduct;
INSERT INTO usersInfo VALUES ('samplecustomer', 'sur','name','abc@acme.com','+49 ...');

DROP USER sampleprogrammer;
CREATE USER sampleprogrammer WITH PASSWORD 'morgen' IN GROUP testproduct;
INSERT INTO usersInfo VALUES ('sampleprogrammer', 'vor','name','abc@itit.com','+49 ...');

INSERT INTO tickets VALUES (0, 'testproduct','0.1','Linux','Enhancement','sound for events','have nice sounds for special events');
INSERT INTO stati VALUES (0,0,'today','samplecustomer','unconfirmed');
INSERT INTO stati VALUES (1,0,'now','sampleprogrammer','new');
INSERT INTO stati VALUES (2,0,'tomorrow','sampleprogrammer','resolved');


--select productid, subject, category, date from tickets, stati where tickets.ticketid=stati.ticketid order by tickets.ticketid, date;


