
package require Pgtcl;
package provide tticketProduct 0.1

namespace eval ::tticket {
    # procs defined here
    namespace export newProduct listProducts 
    namespace export getProductDescription setProductDescription
    namespace export addProductUser dropProductUser listProductUser
}




# create a new product
proc ::tticket::newProduct {userID name {description "no description available"} } {
    set db [resolveDB $userID]
    #
    # as 'CREATE GROUP: may not be called in a transaction block'
    # do our own transaction here :-(
    
    # insert into products
    set sql "insert into products values ('$name', '$description')"
    set h [pg_exec $db $sql]
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	pg_result [pg_exec $db "rollback"] -clear
	error "error inserting product: $msg"
    }

    # create a new group with ticketmaster as default user
    set sql "create group $name with user ticketmaster"
    set h [pg_exec $db $sql]
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	pg_result [pg_exec $db "delect from products where name='$name'"] -clear
	error "error creating group: $msg"
    }
    
    return $name
}


# list all products
proc ::tticket::listProducts {userID} {

    set db [resolveDB $userID]

    set sql "select name from products"
    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error listing products: $msg"
    }

    for {set i 0} {$i < [pg_result $h -numTuples]} {incr i} {
	lappend retval [pg_result $h -getTuple $i]
    }
    pg_result $h -clear

    return $retval
}

# deletion of products not supported so far

#
# handle product description
#

# describe a product
proc ::tticket::getProductDescription {userID name} {
    set db [resolveDB $userID]
    set sql "select name, description from products where name='$name'"
    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error getting description: $msg"
    }
    set description [lindex [pg_result $h -getTuple 0] 1]
    pg_result $h -clear 

    return $description
}

# set product description
proc ::tticket::setProductDescription {userID name description} {
    set db [resolveDB $userID]
    set sql "update products set description='$description' where name='$name'"
    set h [pg_exec $db $sql]
    
    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error setting description: $msg"
    }

    pg_result $h -clear
}


#
# User management for a product
#

# add a user to a product
proc ::tticket::addProductUser {userID product users} {
    set db [resolveDB $userID]

    set sql "ALTER GROUP $product ADD USER [join $users ,]"
    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error listing products: $msg"
    }

    pg_result $h -clear
}

# delete a user from a product
proc ::tticket::dropProductUser {userID product user} {
    set db [resolveDB $userID]
    if {[string equals $user ticketmaster]} {
	error "could not drop ticketmaster"
    }

    set sql "ALTER GROUP $product DROP USER $user"
    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error listing products: $msg"
    }

    pg_result $h -clear
}

# list product users
proc ::tticket::listProductUsers {userID product} {
    set db [resolveDB $userID]
    set sql "SELECT grolist FROM pg_group WHERE groname='$product'"
    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error listing product users: $msg"
    }

    set grolist [join [join [pg_result $h -getTuple 0]]]
    pg_result $h -clear

    # resolve full names for the user ids
    set sql "SELECT usename FROM pg_user WHERE usesysid in ( $grolist )"
    set h [pg_exec $db $sql]
    for {set i 0} {$i < [pg_result $h -numTuples]} {incr i} {
	lappend retval [pg_result $h -getTuple $i]
    }
    pg_result $h -clear

    return $retval
}




