#
# Ticket handling for tticket
#

package require Pgtcl;
package provide tticketTicket 0.1

namespace eval ::tticket {
    # procs defined here
    namespace export 
}

# create a complete new ticket
proc ::tticket::newTicket {userID user productid version platform priority  subject description} {
    set db [resolveDB $userID]

    # do all in an transaction
    set h [pg_exec "BEGIN WORK"]
    pg_result $h -clear

    # insert values into tickets
    set sql "INSERT INTO tickets (productid, version, platform, priority, subject, description) VALUES "
    append sql "('$productid', '$version', '$platform', '$priority', '$subject', '$description')"

    set h [pg_exec $db $h]
    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	pg_exec $db "ROLLBACK"
	error "error creating ticket: $msg"
    }

    # get the new generated ticketid
    set oid [pg_result $h -oid]
    pg_result $h -clear
    set h [pg_exec $db "SELECT ticketId from tickets where oid=$oid"]
    set ticketid [pg_result $h -getTuple 0]
    pg_result $h -clear

    # create the first status
    set sql "INSERT INTO stati (ticketid, issuedBy, category) VALUES "
    append sql "($ticketid, '$name', '$category',  'unconfirmed')"

    set h [pg_exec $db $sql]
    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	pg_exec $db "ROLLBACK"
	error "error creating ticket: $msg"
    }

    pg_result $h -clear

    # commit transaction
    set h [pg_exec "COMMIT WORK"]
    pg_result $h -clear

    return $ticketid
}

proc ::tticket::changeStatus {userID ticketid name category {description ""}} {
    set db [resolveDB $userID]

    set sql "INSERT INTO stati (ticketid, name, category, description) VALUES "
    append sql "($ticketid, '$name', '$category', '$description')"

    set h [pg_exec $db $h]
    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	pg_exec $db "ROLLBACK"
	error "error creating ticket: $msg"
    }


}