#
# User handling for tticket
#

package require Pgtcl;
package provide tticketUser 0.1

namespace eval ::tticket {
    # procs defined here
    namespace export newUser dropUser listUsers getUserInfo
}

# Create a new user
proc ::tticket::newUser {userID name password firstname lastname email telephone } {
    set db [resolveDB $userID]

    # create the system user
    set sql "CREATE USER $name WITH PASSWORD='$password'"
    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error creating user: $msg"
    }
    pg_result $h -clear

    # and save the additional information
    set sql "INSERT INTO usersinfo VALUES ('$name', '$firstname', '$lastname', '$email', '$telephone')"
    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	
	error "error saving additional information: $msg"
    }
    pg_result $h -clear
}

# delete a user
proc ::tticket::dropUser {userID name} {
    set db [resolveDB $userID]
    
    # delete the additional info
    set sql "DELETE FROM usersinfo WHERE usename = '$name'"
    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	
	error "error saving additional information: $msg"
    }
    pg_result $h -clear

    # then drop the db user
    set sql "DROP USER $name"

    set h [pg_exec $db $sql]

    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	
	error "error saving additional information: $msg"
    }
    pg_result $h -clear
}

# list tticket users
proc ::tticket::listUsers {userID} {
    set db [resolveDB $userID]

    set sql "SELECT usename FROM usersinfo"
    set h [pg_exec $db $sql]
    # error handling
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error listing products: $msg"
    }
    for {set i 0} {$i < [pg_result $h -numTuples]} {incr i} {
	lappend retval [pg_result $h -getTuple $i]
    }
    pg_result $h -clear

    return $retval
}

# get info about a user
proc ::tticket::getUserInfo {userID name} {
    set db [resolveDB $userID]

    set sql "SELECT * from usersinfo WHERE usename='$name'"
    set h [pg_exec $db $sql]
    if {[string length [set msg [pg_result $h -error]]]} {
	pg_result $h -clear
	error "error listing products: $msg"
    }
    
    pg_result $h -assign res
    pg_result $h -clear

    return [array get res]
}